#ifndef _GM_CVSEXPORTER_H_
#define _GM_CVSEXPORTER_H_



typedef enum {
	TERMINATOR_TYPE_LINEFEED        = 1 << 0, /* \n */
	TERMINATOR_TYPE_RETURN          = 1 << 1, /* \r */
	TERMINATOR_TYPE_RETURN_LINEFEED = 1 << 2, /* \r\n */
	TERMINATOR_TYPE_UNKNOWN         = 1 << 3  /* Dummy entry */
} CsvTerminatorType;


typedef struct {
	GtkOptionMenu *format_termination;
	GtkOptionMenu *format_separator;
	GtkEntry      *format_custom;
} FormatData;





typedef struct {
    CsvTerminatorType     terminator_type;      /* Desired line terminator */
    gchar                 cell_separator;       /* Desired cell separator */
    GtkWidget             *dialog;                     /* The main window */
    FormatData            *format_data;
    gboolean              canceled;                   /* Indicates weather the user canceled */
    GmPluginData * pd;    
} CsvConfigPageData;




#endif
