#ifndef _GM_HTMLEXPORTER_H_
#define _GM_HTMLEXPORTER_H_

enum {
    NO_HEADER=0,
    SHOW_HEADER_ON_FIRST_PAGE,
    SHOW_HEADER_ON_EVERY_PAGE
};


enum {
    TABLE_LEFT_ALIGN=0,
    TABLE_RIGHT_ALIGN,
    TABLE_CENTER_ALIGN
};


typedef struct 
{
    gint rows_per_page;
    gchar   *table_width;
    gchar   *body_bgcolor;
    gchar   *text_color;    
    gchar   *links_color;    
    gchar   *h_bgcolor;    
    gchar   *h_text;    
    gchar   *rows_bgcolor;    
    gchar   *a_rows_bgcolor;    
    gchar   *grid_color;
    gchar   *html_header;
    gchar   *html_footer;
    gint     show_header;
    gint     table_alignment;    
} HtmlData;


typedef struct {

    GtkWidget  *dialog;                     /* The main window */
    GnomeDruid *html_druid;    
    GtkWidget  *header_page;
    GtkWidget  *color_options_page;
    GtkWidget  *last_page; 
    GtkWidget  *header_text_widget;    
    GtkWidget  *footer_text_widget;    
    GtkEntry   *body_bgcolor;
    GtkEntry   *text_color;    
    GtkEntry   *links_color;    
    GtkEntry   *h_bgcolor;    
    GtkEntry   *h_text;    
    GtkEntry   *rows_bgcolor;    
    GtkEntry   *a_rows_bgcolor;    
    GtkEntry   *grid_color; 
    GtkToggleButton *rb_no_header;    
    GtkToggleButton *rb_header_on_first;
    GtkToggleButton *rb_header_on_every;
    GtkEntry      *rows_per_page;
    GtkEntry      *table_width;
    GtkOptionMenu *table_alignment;
    gboolean    canceled;                   /* Indicates weather the user canceled */

    HtmlData *hdata;    
    GmPluginData * pd;    
} HtmlConfigPageData;




#endif
