#ifndef _BPANEL_H__
#define _BPANEL_H__
#include <gnome.h>
#include "gm-app.h"
#include "gm-clist.h"
#include "gm-dbapi.h"

typedef struct _BpanelViewInfo BpanelViewInfo;
typedef struct _DbBrowserNodeInfo DbBrowserNodeInfo;


struct _BpanelViewInfo{
    DbTableInfo * table_info;
    gint     view_type;
    gchar  * database_in_use;
    gchar  * table_in_use;
    gint     last_view_row_pos;
    gint     row_pos;
    gint     rows_count;
    GSList * fields_list;
};



struct _DbBrowserNodeInfo
{
    gint    sorted_by_column;
    gint    selected_row;
    gint    sort_direction;
    gchar    * filter_query;
    gboolean  filter_enabled;
    gint    type;
    gchar * name;
    GList * text_fields;
};


enum {
    HOSTS_VIEW = 0,
    DATABASES_VIEW,
    TABLES_VIEW ,
    ROWS_VIEW
};




void gm_bpanel_init (GmConnection *connection);
void gm_bpanel_reload (void * ignore, GmConnection * connection);
void  gm_bpanel_free_view_info (BpanelViewInfo * view_info);
void bpanel_append_notebook_page_with_icon (GtkNotebook *note_book, GtkWidget * note_book_page, gchar * titel, gchar * icon_name);
void gm_bpanel_new_data_list_row (GmClist * mlist, GmConnection * connection);
void gm_bpanel_edit_selected_row (GtkButton *button, GmConnection *connection);
void gm_bpanel_go_up (void *ignore, GmConnection * connection);
void gm_bpanel_show_filter_dialog (void *ignore, GmConnection * connection) ;
void gm_bpanel_delete_selected_row (void *ignore, GmConnection *connection);
void gm_bpanel_export_selected_row (GtkButton *button, GmConnection *connection);
void gm_bpanel_select_db_browser_page ( GmConnection * connection);
void gm_bpanel_clean_up (GmConnection * connection );
GSList         * gm_bpanel_clone_fields_list (GSList *src);
void gm_bpanel_free_fields_list (GSList *fields_list) ;

DbBrowserNodeInfo *  gm_bpanel_get_node_info    (GmConnection * connection, BpanelViewInfo * view_info);
DbBrowserNodeInfo *  gm_bpanel_create_node_info (GmConnection * connection, BpanelViewInfo * view_info);
gchar * gm_bpanel_get_view_query (GmConnection * connection, BpanelViewInfo * view_info) ;
void gm_bpanel_go_to_table (gchar * database, gchar * table_name, GmConnection * connection) ;
void gm_bpanel_show_status_information (GmConnection *connection, gchar * message) ;
void gm_bpanel_unselect_all (void *ignore, GmConnection *connection);
void gm_bpanel_select_all (void *ignore, GmConnection *connection);
void gm_bpanel_new_row (GtkButton *button, GmConnection * connection);
void gm_bpanel_save_under (void * ignore, GmConnection * connection) ;
void gm_bpanel_invert_selection (void *ignore, GmConnection *connection);
void gm_bpanel_show_tables (GmConnection *connection, gchar * database) ;


#endif
