#ifndef _GM_CONNECTION_H_
#define _GM_CONNECTION_H_



typedef struct _GmConnection       GmConnection;
typedef struct _GmConnectionClass  GmConnectionClass;
typedef struct _GmConnectionAccessData       GmConnectionAccessData;


struct _GmConnectionAccessData
{
    gchar * host;
    gchar * database;
    gchar * user;
    gchar * password;
    gint port;
};

#define GM_TYPE_CONNECTION            (gm_connection_get_type ())
#define GM_CONNECTION(obj)            (GTK_CHECK_CAST ((obj), GM_TYPE_CONNECTION, GmConnection))
#define GM_CONNECTION_CLASS(klass)    (GTK_CHECK_CLASS_CAST ((klass), GM_TYPE_CONNECTION, GmConnectionClass))
#define GM_IS_CONNECTION(obj)         (GTK_CHECK_TYPE ((obj), GM_TYPE_CONNECTION))
#define GM_IS_CONNECTION_CLASS(klass) (GTK_CHECK_CLASS_TYPE ((klass), GM_TYPE_CONNECTION))


struct _GmConnection
{
    GtkObject object;

    GmConnectionAccessData *access_data;

    GtkWidget * connection_window;
    GtkWidget * query_buffer;
    GtkWidget * mini_buffer;
    GtkWidget * progressbar;
    GtkWidget * dbtree;
    gint remove_messages_timer_tag;


    GtkWidget * qhistory_mlist;
    GtkWidget * dbrowser_popup_menu;
    GtkWidget * data_list; /* data_list is currently being created for each request */
    GHashTable  * info_hash;
    gint key_mode;
    gchar *name;
};




struct _GmConnectionClass
{
    GtkObjectClass parent_class;
};





guint         gm_connection_get_type         (void);
GmConnection * gm_connection_new (void);


#endif /* __GM_APP_H__ */
