#ifndef _GM_CONTROL_CENTER_H_
#define _GM_CONTROL_CENTER_H_
#include <gnome.h>
#include "gm-app.h"


#define GM_TYPE_CCENTER                  (gm_cc_get_type ())
#define GM_CCENTER(obj)                  (GTK_CHECK_CAST ((obj), GM_TYPE_CCENTER, GmCcenter))
#define GM_CCENTER_CLASS(klass)          (GTK_CHECK_CLASS_CAST ((klass), GM_TYPE_CCENTER, GmCcenterClass))
#define GM_IS_CCENTER(obj)               (GTK_CHECK_TYPE ((obj), GM_TYPE_CCENTER))
#define GM_IS_CCENTER_CLASS(klass)       (GTK_CHECK_CLASS_TYPE ((klass), GM_TYPE_CCENTER))
#define GE_CONFIG(app)                   (GM_CCENTER(app->cc)->ge_config)
#define PR_CONFIG(app)                   (GM_CCENTER(app->cc)->pr_config)
#define SQL_EDITOR_CONFIG(app)           (GM_CCENTER(app->cc)->sql_editor_config)

typedef struct _GmCcenter	    GmCcenter;
typedef struct _GmCcenterClass  GmCcenterClass;
typedef struct _GmCcenterDb GmCcenterDb;
typedef struct _GmCcenterGeneral GmCcenterGeneral;
typedef struct _GmCcenterPrinting GmCcenterPrinting;
typedef struct _GmCcenterSqlEditor GmCcenterSqlEditor;
typedef struct _GmHostPort GmHostPort;
typedef struct _GmUserPass GmUserPass;

struct _GmCcenter
{
    GtkObject object;
    GtkWidget *options_dialog;
    GmCcenterGeneral    *ge_config;
    GmCcenterPrinting *pr_config;
    GmCcenterSqlEditor *sql_editor_config;


};


struct _GmHostPort
{
    gchar * host;
    gint port ;
    GList * user_list;
    gchar * last_user;
};


struct _GmUserPass
{
    gchar * user;
    gchar * pass;
};



struct _GmCcenterClass
{
    GtkDataClass parent_class;
};



struct _GmCcenterPrinting{
    gboolean show_table_header;
    gchar *font_name;
    gint   font_size;
    gchar *paper_size;
    gchar *unit_name;    
    gint print_orientation;
    gint print_grid;
};


struct _GmCcenterSqlEditor{
    gchar *font_name;
    gchar *bgcolor;
    gchar *comments_color;
    gchar *keywords_color;
    gchar *functions_color;
    gchar *errors_color;
    gchar *default_color;
    gchar *strings_color;
};




struct _GmCcenterGeneral{
    gboolean delete_confirmation;
    gboolean move_confirmation ;

    gboolean date_time_on;           /* datumsanzeige im logwindow */
    gboolean show_hints;    
    gchar *logfilename;             /* log file */
    FILE  *logfilehandler;
    gboolean show_fields; /* in the dbtree view */

    /* extern */

    gchar *text_editor;
    gchar *browser;

    gchar *dump_file_browser_path ; /* last visited path in the file browser dialog */
    gchar *default_databases_query ;
    gchar *default_tables_query ;
    gchar *default_rows_query ;
    gchar *last_used_exporter;

    gint view_state ;
    gint horizontal_paned_position;
    gint vertical_paned_position;


    GList * host_list; /* Connection host list */

};

struct _GmCcenterDb{

    gchar * username;
    gchar * password;
    gchar * database;
    gchar * hostname;
    gint    port;

    gboolean save_password;

};
enum {
    OPTIONS_GENERAL_PAGE=0,
    OPTIONS_PRINT_PAGE,
    OPTIONS_SQL_EDITOR_PAGE
};






GtkType	      gm_cc_get_type		(void);
GmCcenter   * gm_cc_new                 (GmApp *app);
void          gm_cc_show_option_dialog (GtkObject *obj, gint page);
void gm_cc_update_configuration (void);
void gm_cc_read_configuration (GmCcenter * cc);

#endif 














