#ifndef __GM_DATE_ENTRY_H_
#define __GM_DATE_ENTRY_H_ 

#include <gtk/gtkhbox.h> 
#include <libgnome/gnome-defs.h>




typedef enum {
    GM_DATE_ENTRY_SHOW_TIME             = 1 << 0,
    GM_DATE_ENTRY_24_HR                 = 1 << 1,
    GM_DATE_ENTRY_WEEK_STARTS_ON_MONDAY = 1 << 2
} GmDateEntryFlags;


#define GM_TYPE_DATE_ENTRY            (gm_date_entry_get_type ())
#define GM_DATE_ENTRY(obj)            (GTK_CHECK_CAST ((obj), GM_TYPE_DATE_ENTRY, GmDateEntry))
#define GM_DATE_ENTRY_CLASS(klass)    (GTK_CHECK_CLASS_CAST ((klass), GM_TYPE_DATE_ENTRY, GmDateEntryClass))
#define GNOME_IS_DATE_ENTRY(obj)         (GTK_CHECK_TYPE ((obj), GM_TYPE_DATE_ENTRY))
#define GNOME_IS_DATE_ENTRY_CLASS(klass) (GTK_CHECK_CLASS_TYPE ((klass), GM_TYPE_DATE_ENTRY))

typedef struct {
    GtkHBox hbox;

    GtkWidget *date_entry;
    GtkWidget *date_button;

    gchar * hms;

    GtkWidget *cal_label;
    GtkWidget *cal_popup;
    GtkWidget *calendar;

    int       lower_hour;
    int       upper_hour;

    time_t    initial_time;
    int       flags;
    int       date_format;

} GmDateEntry;

typedef struct {
    GtkHBoxClass parent_class;
    void (*date_changed) (GmDateEntry *gde);
    void (*time_changed) (GmDateEntry *gde);
} GmDateEntryClass;

guint     gm_date_entry_get_type        (void);
GtkWidget *gm_date_entry_new            (time_t the_time, int show_time, int use_24_format, gint date_format);
GtkWidget *gm_date_entry_new_flags      (time_t the_time, GmDateEntryFlags flags, gint date_format);

void      gm_date_entry_set_time        (GmDateEntry *gde, time_t the_time);
void      gm_date_entry_set_popup_range (GmDateEntry *gde, int low_hour, int up_hour);
time_t    gm_date_entry_get_date        (GmDateEntry *gde);
void      gm_date_entry_set_flags       (GmDateEntry *gde, GmDateEntryFlags flags);
int       gm_date_entry_get_flags       (GmDateEntry *gde);
void      gm_date_entry_set_date_format (GmDateEntry *gde, gint date_format);
#endif
