#ifndef _GM_DBTREE_H
#define _GM_DBTREE_H
#include "gm.h"

#define GM_TYPE_DBTREE            (gm_dbtree_get_type ())
#define GM_DBTREE(obj)            (GTK_CHECK_CAST ((obj), GM_TYPE_DBTREE, GmDbtree))
#define GM_DBTREE_CLASS(klass)    (GTK_CHECK_CLASS_CAST ((klass), GM_TYPE_DBTREE, GmDbtreeClass))
#define GM_IS_DBTREE(obj)         (GTK_CHECK_TYPE ((obj), GM_TYPE_DBTREE))
#define GM_IS_DBTREE_CLASS(klass) (GTK_CHECK_CLASS_TYPE ((klass), GM_TYPE_DBTREE))

typedef struct _DbTreeNodeData DbTreeNodeData;

enum {
    ROOT_TYPE = 0,
    HOST_TYPE ,
    DATABASE_TYPE,
    TABLE_TYPE ,
    FIELD_TYPE ,
    KEY_FIELD_TYPE,
    PRIMARY_KEY_FIELD_TYPE,
    TABLE_PROPERTIES_TYPE,
    LAST_NODE_TYPE,
};

enum {
    PIXMAP_STYLE_DEFAULT=0,
    PIXMAP_STYLE_GRAY,
    PIXMAP_STYLE_BLUE_MARKED,
    PIXMAP_STYLE_BLUE
};

struct _DbTreeNodeData
{
    gint type;
    gchar *name;
    gpointer *data;    
    GtkCTreeNode *tree_node ;
};



typedef struct {
    GtkCTree ctree;
    int          visible;

    GNode * data_root_node;
    GtkCTreeNode *root_node;	/* root node */
    GtkCTreeNode *last_node;	/* last visited node */
    GtkWidget *gpixmap_open[LAST_NODE_TYPE];
    GtkWidget *gpixmap_close[LAST_NODE_TYPE];

    /* Pixmaps for showing directories */

    int intern_call;
} GmDbtree;

typedef struct {
    GtkCTreeClass parent_class;

    void (* directory_changed) (GmDbtree *dbtree, char *directory);
} GmDbtreeClass;

guint      gm_dbtree_get_type           (void);
GtkWidget *gm_dbtree_new                (GmConnection *connection);
void      gm_dbtree_construct           (GmDbtree *dbtree);
void      gm_dbtree_build_tree (GmConnection * connection);
void      gm_dbtree_rebuild_tree (void * ignore ,GmConnection * connection);

#endif
