#ifndef GM_HORIZONTAL_SPLITTER_H
#define GM_HORIZONTAL_SPLITTER_H

#include <libgnome/gnome-defs.h>
#include "e-hpaned.h"

BEGIN_GNOME_DECLS

#define GM_TYPE_HORIZONTAL_SPLITTER            (gm_horizontal_splitter_get_type ())
#define GM_HORIZONTAL_SPLITTER(obj)            (GTK_CHECK_CAST ((obj), GM_TYPE_HORIZONTAL_SPLITTER, GmHorizontalSplitter))
#define GM_HORIZONTAL_SPLITTER_CLASS(klass)    (GTK_CHECK_CLASS_CAST ((klass), GM_TYPE_HORIZONTAL_SPLITTER, GmHorizontalSplitterClass))
#define GM_IS_HORIZONTAL_SPLITTER(obj)         (GTK_CHECK_TYPE ((obj), GM_TYPE_HORIZONTAL_SPLITTER))
#define GM_IS_HORIZONTAL_SPLITTER_CLASS(klass) (GTK_CHECK_CLASS_TYPE ((klass), GM_TYPE_HORIZONTAL_SPLITTER))

typedef struct GmHorizontalSplitterDetails GmHorizontalSplitterDetails;

typedef struct {
    EHPaned					parent_slot;
    GmHorizontalSplitterDetails	*details;
} GmHorizontalSplitter;

typedef struct {
    EHPanedClass				parent_slot;
    void   (*collapsed)          (GmHorizontalSplitter       *vsplliter,
                                  gint state);
} GmHorizontalSplitterClass;

/* enum for expand direction
 * GO_LEFT    |
 *            |
 *            | 
 *            |
 *            |
 *            /
 *            /
 *            /
 *            |
 *            |
 *            | GO_RIGHT
 */


enum {
    GO_LEFT =0,
    GO_RIGHT
};

/* GmHorizontalSplitter public methods */
GtkType    gm_horizontal_splitter_get_type (void);
GtkWidget *gm_horizontal_splitter_new      (void);

void	   gm_horizontal_splitter_collapse	(GmHorizontalSplitter *splitter, gint direction);
void	   gm_horizontal_splitter_expand		(GmHorizontalSplitter *splitter);
void	   gm_horizontal_splitter_toggle_position	(GmHorizontalSplitter *splitter, gint direction);



END_GNOME_DECLS

#endif /* GM_HORIZONTAL_SPLITTER_H */








