#ifndef _GM_QUERY_BUFFER_H_
#define _GM_QUERY_BUFFER_H_
#include <gnome.h>
#define WITH_REGEX
#ifdef WITH_REGEX
#include <sys/types.h>
#include <regex.h>
#endif
#define GM_TYPE_QUERY_BUFFER                  (gm_query_buffer_get_type ())
#define GM_QUERY_BUFFER(obj)                  (GTK_CHECK_CAST ((obj), GM_TYPE_QUERY_BUFFER, GmQueryBuffer))
#define GM_QUERY_BUFFER_CLASS(klass)          (GTK_CHECK_CLASS_CAST ((klass), GM_TYPE_QUERY_BUFFER, GmQueryBufferClass))
#define GM_IS_QUERY_BUFFER(obj)               (GTK_CHECK_TYPE ((obj), GM_TYPE_QUERY_BUFFER))
#define GM_IS_QUERY_BUFFER_CLASS(klass)       (GTK_CHECK_CLASS_TYPE ((klass), GM_TYPE_QUERY_BUFFER))


typedef struct _GmQueryBuffer	    GmQueryBuffer;
typedef struct _GmQueryBufferClass  GmQueryBufferClass;

typedef struct _Regex {
    struct re_pattern_buffer buf;
    struct re_registers reg;
} Regex;



typedef struct _HighlightPattern
{
    Regex regex;

    gint     * key;
    GdkFont  * font;
    GdkColor * bg_color;
    GdkColor * fg_color;
    gint ref_count;
} HighlightPattern;





struct _GmQueryBuffer
{
    GtkText text;

    GCompletion *completion;
    GList *highlight_pattern_list ;


    gchar * remember_message ;

    gint remove_messages_timer_tag;
    gint remember_cursor_pos;
    gint history_position;

    gboolean compl_cycling;
};



struct _GmQueryBufferClass
{
    GtkTextClass parent_class;
};


enum {
    GM_QUERY_BUFFER_LAST_SIGNAL=0
};






GtkType    gm_query_buffer_get_type		(void);
GtkWidget* gm_query_buffer_new                  (GmConnection * connection);
void       gm_query_buffer_add_to_history             (GmQueryBuffer *query_buffer, gchar * sql_query);
void       gm_query_buffer_save_history          (GmQueryBuffer   *query_buffer);

void gm_query_buffer_execute_query(void * ignore, GmQueryBuffer *query_buffer);
void gm_query_buffer_set_cursor_at_error_position (GmConnection * connection, DbQuery * q);

#endif /* __GM_QUERY_BUFFER_H__ */
