#ifndef GM_REGEX_H
#define GM_REGEX_H
#include <sys/types.h>
#include <regex.h>





typedef struct {
    int size;		/* Total number of cache slots.  */
    int next;		/* Next available slot.  */
    char **regexs;		/* Regular expression strings.  */
    regex_t *patterns;	/* Compiled expressions.  */
} GmRegexCache;

/* Create a new regular expression cache with default number of
   items.  */
GmRegexCache *gm_regex_cache_new (void);

/* Free a regular expression cache.  */
void gm_regex_cache_destroy (GmRegexCache *rxc);

/* Change number of cache slots.  */
void gm_regex_cache_set_size (GmRegexCache *rxc, int new_size);

/* Compile a regular expression.  */
regex_t *gm_regex_cache_compile (GmRegexCache *rxc, const char *pattern,
                                 int flags);




#endif /* GM_REGEX_H */
