#ifndef GM_VERTICAL_SPLITTER_H
#define GM_VERTICAL_SPLITTER_H

#include <libgnome/gnome-defs.h>
#include "e-vpaned.h"

BEGIN_GNOME_DECLS

#define GM_TYPE_VERTICAL_SPLITTER            (gm_vertical_splitter_get_type ())
#define GM_VERTICAL_SPLITTER(obj)            (GTK_CHECK_CAST ((obj), GM_TYPE_VERTICAL_SPLITTER, GmVerticalSplitter))
#define GM_VERTICAL_SPLITTER_CLASS(klass)    (GTK_CHECK_CLASS_CAST ((klass), GM_TYPE_VERTICAL_SPLITTER, GmVerticalSplitterClass))
#define GM_IS_VERTICAL_SPLITTER(obj)         (GTK_CHECK_TYPE ((obj), GM_TYPE_VERTICAL_SPLITTER))
#define GM_IS_VERTICAL_SPLITTER_CLASS(klass) (GTK_CHECK_CLASS_TYPE ((klass), GM_TYPE_VERTICAL_SPLITTER))

typedef struct GmVerticalSplitterDetails GmVerticalSplitterDetails;

typedef struct {
    EVPaned					parent_slot;
    GmVerticalSplitterDetails	*details;
} GmVerticalSplitter;

typedef struct {
    EVPanedClass				parent_slot;
    void   (*collapsed)          (GmVerticalSplitter       *vsplliter,
                                  gint state);


} GmVerticalSplitterClass;




enum {
    GO_UP =0,
    GO_DOWN
};






/* GmVerticalSplitter public methods */
GtkType    gm_vertical_splitter_get_type (void);
GtkWidget *gm_vertical_splitter_new      (void);

void	   gm_vertical_splitter_collapse	(GmVerticalSplitter *splitter, gint direction);
void	   gm_vertical_splitter_expand		(GmVerticalSplitter *splitter);
void       gm_vertical_splitter_toggle_position (GmVerticalSplitter *splitter, gint direction);
gboolean gm_vertical_splitter_is_collapsed (GmVerticalSplitter * splitter) ;



END_GNOME_DECLS

#endif /* GM_VERTICAL_SPLITTER_H */








